package colour_pkg IS

-------------------------------------------------------------------------
-- definition of the colour_system
-------------------------------------------------------------------------
TYPE colour IS (zwart, rood, groen, blauw, geel, paars, turq, wit);

-------------------------------------------------------------------------
-- overload functions
-------------------------------------------------------------------------
FUNCTION "+" (l:colour; r: colour) RETURN colour;

end colour_pkg;

package body colour_pkg IS

-------------------------------------------------------------------------
-- table for the + function
-------------------------------------------------------------------------
TYPE colour_table is ARRAY(colour, colour) OF colour;

CONSTANT add_table:colour_table := (
-- ----------------------------------------------------------------------
--| zwart   rood  groen  blauw   geel  paars   turq   wit      |     |
-- ----------------------------------------------------------------------
  ( zwart,  rood, groen, blauw,  geel, paars,  turq,  wit), -- |zwart|
  (  rood,  rood,  geel, paars,  geel, paars,   wit,  wit), -- |rood |
  ( groen,  geel, groen,  turq,  geel,   wit,  turq,  wit), -- |groen|
  ( blauw, paars,  turq, blauw,   wit, paars,  turq,  wit), -- |blauw|
  (  geel,  geel,  geel,   wit,  geel,   wit,   wit,  wit), -- |geel |
  ( paars, paars,   wit, paars,   wit, paars,   wit,  wit), -- |paars|
  (  turq,   wit,  turq,  turq,   wit,   wit,  turq,  wit), -- |turq |
  (   wit,   wit,   wit,   wit,   wit,   wit,   wit,  wit)  -- |wit  |
  );

-------------------------------------------------------------------------
-- overload functions
-------------------------------------------------------------------------
   FUNCTION "+" (l: colour; r: colour) RETURN colour IS
   BEGIN
      RETURN (add_table(l, r));
   END "+";

END colour_pkg;









