------------------------------------------------------------------------------
-- Hieronder een voorbeeld van een comparator functie.
-- De file compileert goed en ook de simulatie wordt foutloos uitgevoerd.
-- De resultaten zijn echter wat verrassend: bijv. LLLL > 1111.
-- (voer de simulatie uit om dit te controleren).
-- dit komt omdat vhdl, wanneer verder niets is gespecifieerd, de
-- vergelijking uitvoert door te kijken naar de volgorde waarin de
-- waarden van een type zijn opgegeven.
-- Voor std_logic is dit: {U, X, 0, 1, Z, W, L, H, -}
-- Omdat hier 'L' na '1' komt zal vhdl dus L als groter beschouwen als '1'.
-- Verander nu de code zodanig dat de waarden 'L' en '0' als gelijk worden
-- gezien evenals "h" en '1' en dat 'L' en '0' kleiner zijn dan 'H' en '1'.
-- maak hierbij gebruik van de packages uit de IEEE libary.
-- Beschouw ook de verschillen in uitkomst wanneer a en b worden beschouwd
-- als 'signed' of als 'unsigned'.
------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;

entity comparator is
   port(a:      in  std_logic_vector(3 downto 0);
        b:      in  std_logic_vector(3 downto 0);
        a_lt_b: out std_logic;
        a_eq_b: out std_logic;
        a_gt_b: out std_logic);
end comparator;

architecture beh of comparator is
begin
lbl1: process (a,b)
      begin
         if (a < b) then
            a_lt_b <= '1';
            a_eq_b <= '0';
            a_gt_b <= '0';
         elsif (a = b) then
            a_lt_b <= '0';
            a_eq_b <= '1';
            a_gt_b <= '0';
         else
            a_lt_b <= '0';
            a_eq_b <= '0';
            a_gt_b <= '1';
         end if;
      end process;
end beh;


